\section{BNF Notation}
\label{sec:bnf-notation}

The following BNF notation is used in this paper:
\[\begin{array}{rcll}
   e  & ::= &  e_1\ e_2                &  \hbox{Match the concatenation of two expressions} \\
      &  |  &  e_1 \vbar e_2           &  \hbox{Match either of two expressions} \\
      &  |  &  \kparen{e}              &  \hbox{Match the subexpression $e$} \\
      &  |  &  \kverb{text}            &  \hbox{Match the indicated verbatim text} \\
      &  |  &  \kcharclass{\cdots}     &  \hbox{Match a single character listed in the class} \\
      &  |  &  \kcharclassany          &  \hbox{Match any single character} \\
      &  |  &  \knotcharclass{\cdots}  &  \hbox{Match a single character which is not listed in the class} \\
      &  |  &  \kstar{e}               &  \hbox{Match zero or more occurrences of $e$} \\
      &  |  &  \kquestion{e}           &  \hbox{Match zero or one occurrences of $e$} \\
      &  |  &  \kplus{e}               &  \hbox{Match one or more occurrences of $e$}
\end{array}\]
